local classicAlliance = LootReserve:GetCurrentExpansion() == 0 and "Alliance" or nil;
local classicHorde = LootReserve:GetCurrentExpansion() == 0 and "Horde" or nil

--[[
ClassMask id
1  - 1    - Warrior
2  - 2    - Paladin
3  - 4    - Hunter
4  - 8    - Rogue
5  - 16   - Priest
6  - 32   - Death Knight
7  - 64   - Shaman
8  - 128  - Mage
9  - 256  - Warlock
10 - 512  - Monk
11 - 1024 - Druid
12 - 2048 - Demon Hunter
--]]

LootReserve.Data =
{
    Categories =
    {
        [-100] = {
            Children =
            {
                { Name = "My Reserves", Reserves = "my" },
                { Name = "All Reserves", Reserves = "all" },
                { Name = "|TInterface\\AddOns\\LootReserve\\Textures\\FavoriteWhite:16:16:0:-1:32:32:7:25:2:20|t Favorites", Favorites = true },
                { Name = "|TInterface\\Common\\UI-SearchBox-Icon:16:16:2:-2|t Search Results", Search = true },
            },
        },
        [-50] = {
            Name = "Custom",
            Custom = true,
            Children =
            {
                { Name = "Edited Items", Edited = true },
                { Name = "Custom Items", Custom = true },
            },
        },
        -- Classic
        [1010] = {
            Name = "Molten Core",
            NameShort = "MC",
            Expansion = 0,
            Children =
            {
                {
                    Name = "Lucifron",
                    Loot =
                    {
                        16800, 16805, 16829, 16837, 16859, 16863, 0,
                        19145, 18872, 18875, 19146, 18870, 18861, 0,
                        17109, 19147, 18879, 0,
                        18878, 17077, 0,
                        16665, 0,
                    },
                },
                {
                    Name = "Magmadar",
                    Loot =
                    {
                        16796, 16810, 16814, 16822, 16835, 16847, 16843, 16855, 16867, 0,
                        19136, 18823, 19144, 18829, 18824, 19143, 18861, 0,
                        18820, 18821, 17065, 0,
                        19142, 18203, 18822, 17073, 17069, 0,
                    },
                },
                {
                    Name = "Gehennas",
                    Loot =
                    {
                        16812, 16826, 16849, 16839, 16860, 16862, 0,
                        19145, 18872, 18875, 19146, 18870, 18861, 0,
                        19147, 18879, 0,
                        18878, 17077, 0,
                    },
                },
                {
                    Name = "Garr",
                    Loot =
                    {
                        18564, 0,
                        16795, 16808, 16813, 16821, 16834, 16846, 16842, 16854, 16866, 0,
                        19136, 18823, 19144, 18829, 18824, 19143, 18861, 0,
                        18820, 18821, 0,
                        19142, 17105, 17071, 18832, 18822, 17066, 0,
                    },
                },
                {
                    Name = "Baron Geddon",
                    Loot =
                    {
                        18563, 0,
                        16797, 16807, 16836, 16844, 16856, 0,
                        19136, 18823, 19144, 18829, 18824, 19143, 18861, 0,
                        18820, 18821, 17110, 0,
                        19142, 18822, 0,
                    },
                },
                {
                    Name = "Shazzrah",
                    Loot =
                    {
                        16801, 16803, 16811, 16824, 16831, 16852, 0,
                        19145, 18872, 18875, 19146, 18870, 18861, 0,
                        19147, 18879, 0,
                        18878, 17077, 0,
                    },
                },
                {
                    Name = "Golemagg the Incinerator",
                    Loot =
                    {
                        16798, 16809, 16815, 16820, 16833, 16845, 16841, 16853, 16865, 0,
                        19136, 18823, 19144, 18829, 18824, 19143, 18861, 0,
                        18820, 18821, 0,
                        19142, 17103, 18842, 17072, 18822, 0,
                        17203, 0,
                    },
                },
                {
                    Name = "Sulfuron Harbinger",
                    Loot =
                    {
                        16816, 16823, 16848, 16868, 0,
                        19145, 18872, 18875, 19146, 18870, 18861, 0,
                        18879, 19147, 0,
                        18878, 17077, 17074, 0,
                    },
                },
                {
                    Name = "Majordomo Executus",
                    Loot =
                    {
                        18646, 18703, 0,
                        18809, 18808, 18810, 19139, 18812, 18806, 0,
                        18811, 19140, 0,
                        18805, 18803, 0,
                    },
                },
                {
                    Name = "Ragnaros",
                    Loot =
                    {
                        17204, 0,
                        16915, 16930, 16922, 16909, 16901, 16938, 16946, 16954, 16962, 0,
                        18817, 19137, 0,
                        18814, 19138, 17102, 17107, 17063, 17082, 18815, 0,
                        17106, 18816, 17104, 17076, 0,
                        19017, 21110, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        16802, 16806, 16817, 16827, 16828, 16851, 16838, 16858, 16864, 0,
                        16799, 16804, 16819, 16825, 16830, 16850, 16840, 16857, 16861, 0,
                        17011, 17010, 11382, 17012, 0,
                        20951, 0,
                    },
                },
                {
                    Name = "Recipes",
                    Loot =
                    {
                        18265, 21371, 0,
                        18252, 0,
                        18264, 0,
                        18292, 18291, 18290, 0,
                        18257, 0,
                        18259, 18260, 0,
                    },
                },
            },
        },
        [1020] = {
            Name = "Onyxia",
            NameShort = "Ony",
            Expansion = 0,
            Children =
            {
                {
                    Name = "Onyxia",
                    Loot =
                    {
                        16914, 16929, 16921, 16908, 16900, 16939, 16947, 16955, 16963, 0,
                        18705, 0,
                        18423, 18422, 0,
                        17078, 17064, 18813, 18205, 0,
                        17067, 17068, 17075, 0,
                        17966, 11938, 0,
                        15410, 0,
                    },
                },
            },
        },
        [1030] = {
            Name = "Blackwing Lair",
            NameShort = "BWL",
            Expansion = 0,
            Children =
            {
                {
                    Name = "Razorgore the Untamed",
                    Loot =
                    {
                        16918, 16934, 16926, 16911, 16904, 16935, 16943, 16951, 16959, 0,
                        19337, 19336, 0,
                        19370, 19369, 0,
                        19334, 19335, 0,
                    },
                },
                {
                    Name = "Vaelastrasz the Corrupt",
                    Loot =
                    {
                        16818, 16933, 16925, 16910, 16903, 16936, 16944, 16952, 16960, 0,
                        19339, 19340, 0,
                        19372, 0,
                        19371, 0,
                        19348, 19346, 0,
                    },
                },
                {
                    Name = "Broodlord Lashlayer",
                    Loot =
                    {
                        16912, 16927, 16919, 16906, 16898, 16941, 16949, 16957, 16965, 0,
                        19342, 19341, 0,
                        19374, 19373, 0,
                        19350, 19351, 0,
                        20383, 0,
                    },
                },
                {
                    Name = "Firemaw",
                    Loot =
                    {
                        16913, 16928, 16920, 16907, 16899, 16940, 16948, 16956, 16964, 0,
                        19344, 19343, 0,
                        19400, 19399, 19401, 19396, 19402, 19394, 0,
                        19397, 19395, 19398, 0,
                        19355, 19365, 19353, 0,
                    },
                },
                {
                    Name = "Ebonroc",
                    Loot =
                    {
                        16913, 16928, 16920, 16907, 16899, 16940, 16948, 16956, 16964, 0,
                        19345, 0,
                        19407, 19405, 19396, 19394, 0,
                        19403, 19397, 19395, 19406, 0,
                        19355, 19353, 19368, 0,
                    },
                },
                {
                    Name = "Flamegor",
                    Loot =
                    {
                        16913, 16928, 16920, 16907, 16899, 16940, 16948, 16956, 16964, 0,
                        19430, 19396, 19433, 19394, 0,
                        19397, 19395, 19432, 19431, 0,
                        19355, 19367, 19353, 19357, 0,
                    },
                },
                {
                    Name = "Chromaggus",
                    Loot =
                    {
                        16932, 16924, 16917, 16832, 16902, 16937, 16945, 16953, 16961, 0,
                        19391, 19388, 19385, 19390, 19389, 19393, 19392, 19387, 0,
                        19386, 0,
                        19347, 19352, 19361, 19349, 0,
                    },
                },
                {
                    Name = "Nefarian",
                    Loot =
                    {
                        16916, 16931, 16923, 16905, 16897, 16942, 16950, 16958, 16966, 0,
                        19003, 19002, 0,
                        19375, 19381, 19380, 0,
                        19379, 19378, 19382, 19377, 19376, 0,
                        19356, 19360, 19364, 19363, 0,
                        11938, 0,
                        21138, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        19438, 19437, 19439, 0,
                        19434, 19436, 0,
                        19435, 19362, 19358, 19354, 0,
                        18562, 0,
                    },
                },
            },
        },
        [1040] = {
            Name = "Zul'Gurub",
            NameShort = "ZG",
            Expansion = 0,
            Children =
            {
                {
                    Name = "High Priestess Jeklik",
                    Loot =
                    {
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720, 0,
                        22716, 22720, 19928, 22718, 20262, 22715, 20265, 22714, 0,
                        22721, 19923, 19920, 22722, 0,
                        22713, 19918, 19915, 0,
                    },
                },
                {
                    Name = "High Priest Venoxis",
                    Loot =
                    {
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720, 0,
                        22716, 22720, 19906, 22718, 19904, 22715, 22714, 0,
                        22721, 19905, 19907, 22722, 0,
                        19903, 22713, 19900, 0,
                    },
                },
                {
                    Name = "High Priestess Mar'li",
                    Loot =
                    {
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720, 0,
                        20032, 22716, 22720, 22718, 19919, 22715, 22714, 0,
                        22721, 19930, 22722, 19925, 19871, 0,
                        22713, 19927, 0,
                    },
                },
                {
                    Name = "Bloodlord Mandokir",
                    Loot =
                    {
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720, 0,
                        22637, 0,
                        19895, 19877, 19869, 19878, 0,
                        19893, 19863, 19870, 19873, 0,
                        20038, 19866, 19874, 19867, 0,
                        19872, 0,
                    },
                },
                { Name = "Edge of Madness", Header = true },
                {
                    Name = " - Gri'lek",
                    Loot =
                    {
                        19939, 0,
                        19961, 19962, 0,
                    },
                },
                {
                    Name = " - Hazza'rah",
                    Loot =
                    {
                        19942, 0,
                        19967, 19968, 0,
                    },
                },
                {
                    Name = " - Renataki",
                    Loot =
                    {
                        19940, 0,
                        19964, 19963, 0,
                    },
                },
                {
                    Name = " - Wushoolay",
                    Loot =
                    {
                        19941, 0,
                        19965, 19993, 0,
                    },
                },
                {
                    Name = "High Priest Thekal",
                    Loot =
                    {
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720, 0,
                        19897, 22716, 19899, 22720, 22718, 20260, 22715, 20266, 22714, 0,
                        22721, 19898, 22722, 0,
                        22713, 19901, 19896, 0,
                        19902, 0,
                    },
                },
                {
                    Name = "High Priestess Arlokk",
                    Loot =
                    {
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720, 0,
                        22716, 22720, 22718, 22715, 22714, 19913, 0,
                        22721, 22722, 19912, 0,
                        19922, 19909, 22713, 19910, 0,
                        19914, 0,
                    },
                },
                {
                    Name = "Jin'do the Hexxer",
                    Loot =
                    {
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720, 0,
                        22637, 0,
                        19886, 19929, 19892, 19889, 19887, 19875, 19894, 0,
                        19885, 19888, 0,
                        19891, 19884, 19890, 0,
                    },
                },
                {
                    Name = "Hakkar",
                    Loot =
                    {
                        19802, 0,
                        20257, 20264, 19855, 0,
                        19857, 19876, 19856, 0,
                        19861, 19864, 19859, 19865, 19852, 19854, 19853, 19862, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Gahz'ranka",
                    Loot =
                    {
                        19945, 0,
                        19947, 0,
                        19944, 19946, 0,
                        22739, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        20259, 20261, 20263, 0,
                        20258, 19921, 19908, 0,
                        19707, 19708, 19709, 19710, 19711, 19712, 19713, 19714, 19715, 0,
                        19698, 19699, 19700, 19701, 19702, 19703, 19704, 19705, 19706, 0,
                    },
                },
            },
        },
        [1050] = {
            Name = "Ruins of Ahn'Qiraj",
            NameShort = "AQ20",
            Expansion = 0,
            Children =
            {
                {
                    Name = "Kurinnaxx",
                    Loot =
                    {
                        20885, 20889, 20888, 20884, 0,
                        21499, 21500, 21501, 21502, 21503, 0,
                        21498, 0,
                    },
                },
                {
                    Name = "General Rajaxx",
                    Loot =
                    {
                        20885, 20889, 20888, 20884, 0,
                        21496, 21810, 21493, 21494, 21497, 21495, 0,
                        21809, 0,
                        21806, 21492, 0,
                    },
                },
                {
                    Name = "Moam",
                    Loot =
                    {
                        20884, 20888, 20890, 20886, 0,
                        21472, 21468, 21469, 21455, 21474, 21467, 21476, 21475, 21479, 0,
                        21473, 21470, 21477, 0,
                        21471, 0,
                        22220, 0,
                    },
                },
                {
                    Name = "Buru the Gorger",
                    Loot =
                    {
                        20890, 20886, 20885, 20889, 20888, 20884, 0,
                        21489, 21491, 21487, 21486, 21490, 0,
                        21488, 0,
                        21485, 0,
                    },
                },
                {
                    Name = "Ayamiss the Hunter",
                    Loot =
                    {
                        20890, 20886, 20885, 20889, 20888, 20884, 0,
                        21484, 21482, 21480, 21481, 21479, 0,
                        21483, 0,
                        21466, 21478, 0,
                    },
                },
                {
                    Name = "Ossirian the Unscarred",
                    Loot =
                    {
                        20890, 20886, 20888, 20884, 0,
                        21220, 0,
                        21461, 21464, 21462, 21458, 21454, 21463, 21453, 21457, 21460, 0,
                        21456, 0,
                        21452, 21459, 21715, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        21804, 21803, 21805, 0,
                        21802, 21801, 21800, 0,
                        20873, 20869, 20866, 20870, 20868, 20871, 20867, 20872, 0,
                        20864, 20861, 20863, 20862, 20859, 20865, 20860, 20858, 0,
                        21761, 21156, 0,
                        22203, 22202, 0,
                    },
                },
                {
                    Name = "Enchants",
                    Loot =
                    {
                        20728, 20729, 20727, 20730, 20731, 20734, 20736, 0,
                    },
                },
                {
                    Name = "Class books",
                    Loot =
                    {
                        21279, 21214, 21280, 21281, 21283, 21282, 21284, 21287, 21285, 21300, 21303, 21302, 21294, 21296, 21295, 21306, 21304, 21307, 21291, 21292, 21293, 21288, 21289, 21290, 21298, 21299, 21297, 0,
                    },
                },
            },
        },
        [1060] = {
            Name = "Temple of Ahn'Qiraj",
            NameShort = "AQ40",
            Expansion = 0,
            Children =
            {
                {
                    Name = "The Prophet Skeram",
                    Loot =
                    {
                        21698, 21708, 21705, 21699, 21704, 21814, 21706, 0,
                        21707, 21702, 21701, 21700, 0,
                        21703, 21128, 0,
                        21232, 21237, 0,
                        22222, 0,
                    },
                },
                {
                    Name = "Bug Trio",
                    Loot =
                    {
                        21696, 21694, 21693, 21692, 0,
                        21697, 21695, 0,
                        21237, 21232, 0,
                    },
                },
                {
                    Name = " - Kri Killed Last",
                    Loot =
                    {
                        21680, 0,
                        21681, 21685, 0,
                        21603, 0,
                    },
                },
                {
                    Name = " - Yauj Killed Last",
                    Loot =
                    {
                        21686, 21682, 21684, 21683, 0,
                        21687, 0,
                    },
                },
                {
                    Name = " - Vem Killed Last",
                    Loot =
                    {
                        21689, 21691, 21688, 0,
                        21690, 0,
                    },
                },
                {
                    Name = "Battleguard Sartura",
                    Loot =
                    {
                        21676, 21648, 21671, 21669, 21672, 21675, 21668, 21667, 21674, 0,
                        21678, 21670, 0,
                        21666, 21673, 0,
                        21237, 21232, 0,
                    },
                },
                {
                    Name = "Fankriss the Unyielding",
                    Loot =
                    {
                        21663, 21665, 21645, 21651, 21652, 21639, 0,
                        21647, 21664, 21627, 0,
                        21650, 21635, 22396, 22402, 0,
                        21237, 21232, 0,
                    },
                },
                {
                    Name = "Viscidus",
                    Loot =
                    {
                        20928, 20932, 0,
                        21624, 21626, 21623, 0,
                        21625, 21677, 0,
                        21622, 22399, 0,
                        21237, 21232, 0,
                    },
                },
                {
                    Name = "Princess Huhuran",
                    Loot =
                    {
                        20928, 20932, 0,
                        21619, 21617, 21618, 0,
                        21620, 21621, 0,
                        21616, 0,
                        21237, 21232, 0,
                    },
                },
                {
                    Name = "Twin Emperors",
                    Loot =
                    {
                        20930, 20926, 0,
                        21600, 21604, 21609, 21602, 21605, 21607, 21599, 21606, 21598, 0,
                        21608, 21601, 0,
                        21597, 21679, 0,
                        21232, 21237, 0,
                        20735, 20726, 0,
                    },
                },
                {
                    Name = "Ouro",
                    Loot =
                    {
                        20931, 20927, 0,
                        21611, 21615, 0,
                        23558, 23570, 0,
                        23557, 21610, 0,
                        21237, 21232, 0,
                    },
                },
                {
                    Name = "C'Thun",
                    Loot =
                    {
                        20929, 20933, 0,
                        21221, 0,
                        22730, 21585, 21582, 21586, 21581, 0,
                        22731, 21583, 21596, 21579, 22732, 0,
                        21839, 21126, 21134, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        21838, 21888, 21889, 0,
                        21836, 21891, 0,
                        21856, 21837, 0,
                        21218, 21324, 21323, 21321, 0,
                        22203, 22202, 0,
                    },
                },
                {
                    Name = "Scarabs",
                    Loot =
                    {
                        20876, 20879, 20875, 20878, 20881, 20877, 20874, 20882, 0,
                        20864, 20861, 20863, 20862, 20859, 20865, 20860, 20858, 0,
                        21762, 21156, 0,
                    },
                },
                {
                    Name = "Enchants",
                    Loot =
                    {
                        20728, 20729, 20727, 20730, 20731, 20734, 20736, 0,
                    },
                },
            },
        },
        [1070] = {
            Name = "Naxxramas",
            NameShort = "Naxx",
            Expansion = 0,
            Children =
            {
                {
                    Name = "Anub'Rekhan",
                    Loot =
                    {
                        22369, 22362, 22355, 0,
                        22936, 0,
                        22939, 22935, 22938, 0,
                        22937, 0,
                        22726, 0,
                    },
                },
                {
                    Name = "Grand Widow Faerlina",
                    Loot =
                    {
                        22369, 22362, 22355, 0,
                        22941, 22940, 0,
                        22943, 0,
                        22942, 22806, 0,
                        22726, 0,
                    },
                },
                {
                    Name = "Maexxna",
                    Loot =
                    {
                        22371, 22364, 22357, 0,
                        23220, 0,
                        22947, 22954, 0,
                        22807, 22804, 0,
                        22726, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Noth the Plaguebringer",
                    Loot =
                    {
                        22370, 22363, 22356, 0,
                        23031, 23030, 23028, 0,
                        23029, 23005, 23006, 22816, 0,
                        22726, 0,
                    },
                },
                {
                    Name = "Heigan the Unclean",
                    Loot =
                    {
                        22370, 22363, 22356, 0,
                        23035, 23033, 23068, 23019, 0,
                        23036, 0,
                        22726, 0,
                    },
                },
                {
                    Name = "Loatheb",
                    Loot =
                    {
                        22366, 22359, 22352, 0,
                        23037, 23038, 23042, 0,
                        22800, 23039, 0,
                        22726, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Instructor Razuvious",
                    Loot =
                    {
                        22372, 22365, 22358, 0,
                        23219, 0,
                        23017, 23018, 0,
                        23009, 23004, 23014, 0,
                        22726, 0,
                    },
                },
                {
                    Name = "Gothik the Harvester",
                    Loot =
                    {
                        22372, 22365, 22358, 0,
                        23032, 23021, 23020, 23073, 0,
                        23023, 0,
                        22726, 0,
                    },
                },
                {
                    Name = "The Four Horsemen",
                    Loot =
                    {
                        22351, 22350, 22349, 0,
                        23071, 0,
                        23025, 23027, 0,
                        22811, 22809, 22691, 0,
                        22726, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Patchwerk",
                    Loot =
                    {
                        22368, 22361, 22354, 0,
                        22960, 22961, 0,
                        22820, 22815, 22818, 0,
                        22726, 0,
                    },
                },
                {
                    Name = "Grobbulus",
                    Loot =
                    {
                        22368, 22361, 22354, 0,
                        22968, 22967, 0,
                        22803, 22988, 22810, 0,
                        22726, 0,
                    },
                },
                {
                    Name = "Gluth",
                    Loot =
                    {
                        22368, 22369, 22370, 22372, 22361, 22362, 22363, 22365, 22354, 22355, 22356, 22358, 0,
                        22983, 0,
                        22981, 0,
                        23075, 22994, 22813, 0,
                        22726, 0,
                    },
                },
                {
                    Name = "Thaddius",
                    Loot =
                    {
                        22367, 22360, 22353, 0,
                        23070, 23000, 0,
                        23001, 0,
                        22801, 22808, 0,
                        22726, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Sapphiron",
                    Loot =
                    {
                        23549, 23548, 23545, 23547, 0,
                        23050, 23046, 23047, 23045, 23041, 23040, 0,
                        23049, 23048, 23043, 23242, 0,
                    },
                },
                {
                    Name = "Kel'Thuzad",
                    Loot =
                    {
                        23061, 23062, 23063, 23060, 23064, 23067, 23065, 23066, 23059, 0,
                        22520, 0,
                        23057, 23053, 0,
                        22821, 22799, 22819, 23056, 22802, 23054, 22798, 23577, 22812, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        23069, 23226, 23663, 23664, 23665, 23667, 23666, 23668, 0,
                        23237, 0,
                        23238, 23044, 23221, 0,
                        22376, 22373, 22374, 22375, 0,
                        23055, 22682, 0,
                    },
                },
            },
        },
        -- The Burning Crusade
        [2010] = {
            Name = "Karazhan",
            NameShort = "Kara",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Attumen the Huntsman",
                    Loot =
                    {
                        28477, 28507, 28508, 28453, 28506, 28503, 28454, 28502, 28505, 0,
                        28510, 28509, 0,
                        28504, 0,
                        30480, 0,
                        23809, 0,
                    },
                },
                { Name = "Servant Quarters", Header = true },
                {
                    Name = " - Rokad the Ravager",
                    Loot =
                    {
                        30684, 30685, 30686, 30687, 0,
                    },
                },
                {
                    Name = " - Shadikith the Glider",
                    Loot =
                    {
                        30680, 30681, 30682, 30683, 0,
                    },
                },
                {
                    Name = " - Hyakiss the Lurker",
                    Loot =
                    {
                        30675, 30676, 30677, 30678, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Moroes",
                    Loot =
                    {
                        28565, 28545, 28567, 28569, 28566, 0,
                        28530, 28570, 28529, 28528, 0,
                        28568, 28525, 28524, 0,
                        22559, 0,
                    },
                },
                {
                    Name = "Maiden of Virtue",
                    Loot =
                    {
                        28515, 28517, 28511, 28521, 28514, 28520, 28519, 28512, 28518, 0,
                        28516, 0,
                        28522, 28523, 0,
                    },
                },
                {
                    Name = "Opera Event",
                    Loot =
                    {
                        28594, 28591, 28589, 28593, 0,
                        28590, 0,
                        28592, 0,
                    },
                },
                {
                    Name = " - The Wizard of Oz",
                    Loot =
                    {
                        28586, 28585, 0,
                        28588, 28587, 0,
                    },
                },
                {
                    Name = " - The Big Bad Wolf",
                    Loot =
                    {
                        28583, 0,
                        28582, 0,
                        28581, 28584, 0,
                    },
                },
                {
                    Name = " - Romulo and Julianne",
                    Loot =
                    {
                        28578, 0,
                        28579, 0,
                        28572, 28573, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Nightbane",
                    Loot =
                    {
                        28602, 28600, 28601, 28599, 28610, 28608, 28597, 0,
                        28603, 28609, 0,
                        28604, 28611, 28606, 0,
                    },
                },
                {
                    Name = "The Curator",
                    Loot =
                    {
                        29757, 29758, 29756, 0,
                        28612, 28647, 28631, 28621, 0,
                        28649, 0,
                        28633, 0,
                    },
                },
                {
                    Name = "Terestian Illhoof",
                    Loot =
                    {
                        28654, 28652, 28655, 28656, 28662, 0,
                        28785, 28661, 28653, 28660, 0,
                        28658, 28657, 28659, 0,
                        22561, 0,
                    },
                },
                {
                    Name = "Shade of Aran",
                    Loot =
                    {
                        28726, 28670, 28663, 28669, 28671, 28666, 0,
                        28727, 28674, 28672, 28675, 0,
                        28673, 28728, 0,
                        22560, 0,
                    },
                },
                {
                    Name = "Netherspite",
                    Loot =
                    {
                        28744, 28742, 28732, 28741, 28735, 28740, 28733, 28743, 0,
                        28731, 28730, 0,
                        28734, 28729, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Chess Event",
                    Loot =
                    {
                        28756, 28752, 28755, 28750, 28751, 28746, 28748, 28747, 0,
                        28753, 28745, 0,
                        28754, 28749, 0,
                    },
                },
                {
                    Name = "Prince Malchezaar",
                    Loot =
                    {
                        29760, 29761, 29759, 0,
                        28762, 28766, 28765, 28763, 28764, 28757, 0,
                        28770, 28771, 28767, 28773, 28768, 28772, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        30642, 30668, 30673, 30644, 30674, 30643, 30641, 0,
                        30666, 30667, 0,
                        21903, 21904, 0,
                        22545, 0,
                        23857, 23864, 23862, 23865, 0,
                        21882, 0,
                    },
                },
            },
        },
        [2020] = {
            Name = "Gruul's Lair",
            NameShort = "Gruul",
            Expansion = 1,
            Children =
            {
                {
                    Name = "High King Maulgar",
                    Loot =
                    {
                        29763, 29764, 29762, 0,
                        28799, 28796, 28801, 28795, 0,
                        28797, 0,
                        28800, 0,
                    },
                },
                {
                    Name = "Gruul the Dragonkiller",
                    Loot =
                    {
                        29766, 29767, 29765, 0,
                        28804, 28803, 28828, 28810, 28827, 28824, 0,
                        28822, 28823, 28830, 0,
                        28802, 28826, 28794, 28825, 0,
                    },
                },
            },
        },
        [2030] = {
            Name = "Magtheridon's Lair",
            NameShort = "Mag",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Magtheridon",
                    Loot =
                    {
                        29754, 29753, 29755, 0,
                        32385, 0,
                        28780, 28777, 28776, 28778, 28779, 28775, 0,
                        28789, 0,
                        28783, 28781, 28782, 29458, 28774, 0,
                        34845, 0,
                        34846, 0,
                    },
                },
            },
        },
        [2040] = {
            Name = "Serpentshrine Cavern",
            NameShort = "SSC",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Hydross the Unstable",
                    Loot =
                    {
                        30664, 0,
                        30050, 30056, 32516, 30055, 30047, 30054, 30048, 30053, 0,
                        30052, 33055, 30629, 0,
                        30049, 30051, 0,
                    },
                },
                {
                    Name = "The Lurker Below",
                    Loot =
                    {
                        30665, 0,
                        30064, 30067, 30062, 30060, 30066, 30065, 30057, 0,
                        30059, 30061, 33054, 0,
                        30063, 30058, 0,
                    },
                },
                {
                    Name = "Leotheras the Blind",
                    Loot =
                    {
                        30239, 30240, 30241, 0,
                        30092, 30097, 30091, 30096, 0,
                        30627, 0,
                        30095, 0,
                    },
                },
                {
                    Name = "Fathom-Lord Karathress",
                    Loot =
                    {
                        30663, 0,
                        30245, 30246, 30247, 0,
                        30100, 30101, 0,
                        30626, 30099, 0,
                        30090, 0,
                    },
                },
                {
                    Name = "Morogrim Tidewalker",
                    Loot =
                    {
                        30720, 0,
                        30079, 30075, 30085, 30068, 30084, 30081, 0,
                        30008, 33058, 30098, 30083, 0,
                        30080, 30082, 0,
                    },
                },
                {
                    Name = "Lady Vashj",
                    Loot =
                    {
                        30242, 30243, 30244, 0,
                        30107, 30111, 30106, 30104, 30112, 30102, 0,
                        30109, 30110, 30621, 0,
                        30108, 30103, 30105, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        30027, 0,
                        30022, 30620, 0,
                        30023, 30025, 30021, 0,
                        30183, 0,
                        32897, 0,
                    },
                },
                {
                    Name = "Patterns",
                    Loot =
                    {
                        30280, 30282, 30283, 30281, 0,
                        30308, 30304, 30305, 30307, 30306, 30301, 30303, 30302, 0,
                        30322, 30323, 30321, 30324, 0,
                    }
                },
            },
        },
        [2050] = {
            Name = "The Eye",
            NameShort = "TK",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Al'ar",
                    Loot =
                    {
                        30448, 30447, 0,
                        29918, 29947, 29921, 0,
                        29922, 29920, 29925, 0,
                        29923, 32944, 29948, 29924, 29949, 0,
                    },
                },
                {
                    Name = "Void Reaver",
                    Loot =
                    {
                        30450, 0,
                        30248, 30249, 30250, 0,
                        29986, 29984, 29985, 29983, 32515, 0,
                        30619, 0,
                    },
                },
                {
                    Name = "High Astromancer Solarian",
                    Loot =
                    {
                        30449, 30446, 0,
                        29972, 29977, 29966, 29976, 29951, 29965, 29950, 32267, 0,
                        29982, 29981, 29962, 0,
                    },
                },
                {
                    Name = "Kael'thas Sunstrider",
                    Loot =
                    {
                        30236, 30237, 30238, 0,
                        32405, 0,
                        29987, 29990, 29995, 29991, 29998, 0,
                        29992, 29989, 29994, 29997, 0,
                        29988, 29996, 29993, 0,
                        32458, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        30020, 30024, 30029, 30030, 30026, 0,
                        30028, 0,
                        30183, 0,
                        32897,
                    }
                },
                {
                    Name = "Patterns",
                    Loot =
                    {
                        30280, 30282, 30283, 30281, 0,
                        30308, 30304, 30305, 30307, 30306, 30301, 30303, 30302, 0,
                        30322, 30323, 30321, 30324, 0,
                    }
                },
            },
        },
        [2060] = {
            Name = "Battle for Mount Hyjal",
            NameShort = "Hyjal",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Rage Winterchill",
                    Loot =
                    {
                        30870, 30871, 30868, 30863, 30873, 30869, 30864, 30862, 30866, 30861, 0,
                        30872, 30865, 0,
                    },
                },
                {
                    Name = "Anetheron",
                    Loot =
                    {
                        30884, 30888, 30885, 30886, 30879, 30887, 30880, 30878, 0,
                        30882, 30883, 30881, 30874, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Kaz'rogal",
                    Loot =
                    {
                        30894, 30916, 30895, 30914, 30917, 30891, 30893, 30892, 30919, 30915, 0,
                        30918, 30889, 0,
                    },
                },
                {
                    Name = "Azgalor",
                    Loot =
                    {
                        31092, 31094, 31093, 0,
                        30899, 30898, 30900, 30897, 30896, 0,
                        30901, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Archimonde",
                    Loot =
                    {
                        31097, 31095, 31096, 0,
                        30913, 30912, 30905, 30907, 30904, 30903, 0,
                        30910, 30908, 30911, 30902, 30906, 30909, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        32609, 32592, 0,
                        32589, 32590, 32591, 34010, 0,
                        34009, 32946, 32945, 0,
                        32428, 32897, 0,
                    },
                },
                {
                    Name = "Patterns",
                    Loot =
                    {
                        32296, 32307, 32289, 32285, 32303, 32297, 32298, 32295, 0,
                    },
                },
            },
        },
        [2070] = {
            Name = "Black Temple",
            NameShort = "BT",
            Expansion = 1,
            Children =
            {
                {
                    Name = "High Warlord Naj'entus",
                    Loot =
                    {
                        32239, 32240, 32377, 32242, 32241, 32234, 32243, 32245, 32232, 0,
                        32247, 32238, 0,
                        32237, 32236, 32248, 0,
                    },
                },
                {
                    Name = "Supremus",
                    Loot =
                    {
                        32256, 32252, 32259, 32258, 32251, 32250, 0,
                        32260, 32261, 0,
                        32255, 32257, 32262, 32253, 32254, 0,
                    },
                },
                {
                    Name = "Shade of Akama",
                    Loot =
                    {
                        32270, 32513, 32273, 32271, 32265, 32276, 32275, 32264, 32278, 32279, 32268, 32263, 0,
                        32266, 0,
                        32361, 0,
                    },
                },
                {
                    Name = "Teron Gorefiend",
                    Loot =
                    {
                        32327, 32329, 32328, 32324, 32510, 32512, 32280, 0,
                        32323, 0,
                        32330, 32348, 32326, 32325, 0,
                    },
                },
                {
                    Name = "Gurtogg Bloodboil",
                    Loot =
                    {
                        32340, 32338, 32339, 32334, 32341, 32342, 32333, 0,
                        32337, 32335, 32501, 0,
                        32343, 32344, 32269, 0,
                    },
                },
                {
                    Name = "Reliquary of the Lost",
                    Loot =
                    {
                        32353, 32352, 32351, 32347, 32517, 32346, 32354, 32345, 0,
                        32349, 32362, 0,
                        32350, 32363, 32332, 0,
                    },
                },
                {
                    Name = "Mother Shahraz",
                    Loot =
                    {
                        31101, 31103, 31102, 0,
                        32367, 32366, 32365, 0,
                        32370, 32369, 32368, 0,
                    },
                },
                {
                    Name = "The Illidari Council",
                    Loot =
                    {
                        31098, 31100, 31099, 0,
                        32519, 32518, 32376, 32373, 0,
                        32331, 32505, 0,
                    },
                },
                {
                    Name = "Illidan Stormrage",
                    Loot =
                    {
                        31089, 31091, 31090, 0,
                        32837, 32838, 0,
                        32525, 32235, 32521, 0,
                        32483, 32496, 32524, 32497, 0,
                        32374, 32500, 32471, 32336, 32375, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        32609, 32593, 32592, 32606, 32608, 0,
                        32589, 32590, 32527, 32528, 34012, 32526, 32591, 0,
                        34009, 32943, 34011, 0,
                        32228, 32231, 32229, 32249, 32230, 32227, 0,
                        32428, 32897, 0,
                    },
                },
                {
                    Name = "Patterns",
                    Loot =
                    {
                        32754, 32755, 32753, 32752, 0,
                        32744, 32745, 32746, 32747, 32750, 32751, 32748, 32749, 0,
                        32738, 32739, 32736, 32737, 0,
                    },
                },
            },
        },
        [2080] = {
            Name = "Zul'Aman",
            NameShort = "ZA",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Akil'zon",
                    Loot =
                    {
                        33286, 33216, 33215, 0,
                        33293, 33281, 0,
                        33283, 33214, 0,
                        33307, 0,
                    },
                },
                {
                    Name = "Nalorakk",
                    Loot =
                    {
                        33285, 33203, 33211, 33206, 33327, 33191, 0,
                        33640, 0,
                        33307, 0,
                    },
                },
                {
                    Name = "Jan'alai",
                    Loot =
                    {
                        33357, 33356, 33329, 33328, 0,
                        33354, 33332, 33326, 0,
                        33307, 0,
                    },
                },
                {
                    Name = "Halazzi",
                    Loot =
                    {
                        33317, 33322, 33300, 33533, 33299, 33303, 0,
                        33297, 0,
                        33307, 0,
                    },
                },
                {
                    Name = "Hex Lord Malacrass",
                    Loot =
                    {
                        33453, 33463, 33432, 33464, 33421, 33446, 0,
                        33829, 33828, 33592, 34029, 0,
                        33465, 33389, 33298, 33388, 0,
                        33307, 0,
                    },
                },
                {
                    Name = "Zul'jin",
                    Loot =
                    {
                        33471, 33479, 33469, 33473, 0,
                        33466, 33831, 33830, 0,
                        33467, 33468, 33474, 33478, 33476, 0,
                        33307, 0,
                        33102, 0,
                    },
                },
                { Separator = true },
                { Name = "Timed Chests", Header = true },
                {
                    Name = " - First Prisoner Saved",
                    Loot =
                    {
                        33489, 33480, 33971, 33483, 33805, 33481, 0,
                        33591, 33590, 0,
                    },
                },
                {
                    Name = " - Second Prisoner Saved",
                    Loot =
                    {
                        33494, 33490, 33495, 33493, 33492, 33491, 0,
                    },
                },
                {
                    Name = " - Third Prisoner Saved",
                    Loot =
                    {
                        33497, 33498, 33496, 33500, 33499, 0,
                    },
                },
                {
                    Name = " - Fourth Prisoner Saved",
                    Loot =
                    {
                        33809, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        33993, 0,
                        33865, 33930, 33932, 33931, 33933, 0,
                    },
                },
            },
        },
        [2090] = {
            Name = "Sunwell Plateau",
            NameShort = "SWP",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Kalecgos",
                    Loot =
                    {
                        34848, 34851, 34852, 0,
                        34386, 34170, 34169, 34384, 34168, 34167, 34382, 0,
                        34166, 0,
                        34165, 34164, 0,
                    },
                },
                {
                    Name = "Brutallus",
                    Loot =
                    {
                        34853, 34854, 34855, 0,
                        34181, 34180, 34381, 0,
                        34177, 34178, 0,
                        34179, 34176, 0,
                    },
                },
                {
                    Name = "Felmyst",
                    Loot =
                    {
                        34856, 34857, 34858, 0,
                        34188, 34385, 34186, 34383, 34352, 0,
                        34184, 0,
                        34182, 34185, 0,
                    },
                },
                {
                    Name = "Eredar Twins",
                    Loot =
                    {
                        34210, 34393, 34202, 34391, 34209, 34392, 34195, 34390, 34208, 34194, 34193, 34388, 34389, 34192, 0,
                        35290, 34204, 35291, 34205, 34189, 35292, 34190, 0,
                        34206, 34199, 34198, 34197, 34203, 34196, 0,
                    },
                },
                {
                    Name = "M'uru",
                    Loot =
                    {
                        34232, 34399, 34233, 34398, 34212, 34211, 34397, 34234, 34408, 34396, 34229, 34228, 34395, 34240, 34215, 34216, 34394, 0,
                        34230, 35282, 34429, 34430, 35283, 35284, 34427, 34428, 34213, 0,
                        34231, 34214, 0,
                    },
                },
                {
                    Name = "Kil'jaeden",
                    Loot =
                    {
                        34334, 0,
                        34405, 34340, 34406, 34344, 34339, 34342, 34403, 34245, 34404, 34244, 34332, 34402, 34333, 34343, 34243, 34345, 34341, 34401, 34400, 0,
                        34242, 34241, 0,
                        34336, 34335, 34337, 34329, 34247, 34331, 0,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        34407, 34351, 34409, 34350, 0,
                        35733, 0,
                        34347, 34348, 34349, 34183, 34346, 0,
                        35273, 0,
                        32228, 32231, 32229, 32249, 32230, 32227, 0,
                        34664, 0,
                    },
                },
                {
                    Name = "Patterns",
                    Loot =
                    {
                        35186, 35189, 35197, 35190, 35191, 35192, 35193, 35194, 35187, 35195, 35196, 0,
                        35204, 35206, 35205, 35207, 0,
                        35212, 35216, 35213, 35217, 35214, 35218, 35215, 35219, 0,
                        35208, 35210, 35209, 35211, 0,
                        35198, 35201, 35199, 35202, 35200, 35203, 0,
                    },
                },
            },
        },
    },
    ItemConditions =
    {
        -- Molten Core trash
        [11382] = { Hidden = true },
        [17010] = { Hidden = true },
        [17011] = { Hidden = true },
        [17012] = { Hidden = true },
        [20951] = { Hidden = true },

        -- Thunderfury items
        [18563] = { ClassMask = 15, Hidden = true },
        [18564] = { ClassMask = 15, Hidden = true },
        [17203] = { Hidden = true },
        [18562] = { Hidden = true },

        -- Hand of Rag items
        [17204] = { ClassMask = 1091, Hidden = true },
        [19017] = { ClassMask = 1091, Hidden = true },

        -- Scale of Onyxia
        [15410] = { Hidden = true },

        -- Head of Onyxia
        [18422] = { Faction = "Horde" },
        [18423] = { Faction = "Alliance" },

        -- Head of Nefarian
        [19002] = { Faction = "Horde" },
        [19003] = { Faction = "Alliance" },

        -- Red Scepter Shard
        [21138] = { Hidden = true },

        -- Sack of Gems
        [11938] = { Hidden = true },

        -- ZG Coins
        [19698] = { Hidden = true },
        [19699] = { Hidden = true },
        [19700] = { Hidden = true },
        [19701] = { Hidden = true },
        [19702] = { Hidden = true },
        [19703] = { Hidden = true },
        [19704] = { Hidden = true },
        [19705] = { Hidden = true },
        [19706] = { Hidden = true },

        -- ZG Bijous
        [19707] = { Hidden = true },
        [19708] = { Hidden = true },
        [19709] = { Hidden = true },
        [19710] = { Hidden = true },
        [19711] = { Hidden = true },
        [19712] = { Hidden = true },
        [19713] = { Hidden = true },
        [19714] = { Hidden = true },
        [19715] = { Hidden = true },

        --AQ20 idols
        [20866] = { ClassMask = 140, Hidden = true },
        [20867] = { ClassMask = 265, Hidden = true },
        [20868] = { ClassMask = 21, Hidden = true },
        [20869] = { ClassMask = 326, Hidden = true },
        [20870] = { ClassMask = 1296, Hidden = true },
        [20871] = { ClassMask = 210, Hidden = true },
        [20872] = { ClassMask = 1098, Hidden = true },
        [20873] = { ClassMask = 1153, Hidden = true },

        -- AQ40 idols
        [20874] = { ClassMask = 141, Hidden = true },
        [20875] = { ClassMask = 393, Hidden = true },
        [20876] = { ClassMask = 401, Hidden = true },
        [20877] = { ClassMask = 466, Hidden = true },
        [20878] = { ClassMask = 1362, Hidden = true },
        [20879] = { ClassMask = 1110, Hidden = true },
        [20881] = { ClassMask = 1102, Hidden = true },
        [20882] = { ClassMask = 1037, Hidden = true },

        -- AQ scarabs
        [20858] = { Hidden = true },
        [20859] = { Hidden = true },
        [20860] = { Hidden = true },
        [20861] = { Hidden = true },
        [20862] = { Hidden = true },
        [20863] = { Hidden = true },
        [20864] = { Hidden = true },
        [20865] = { Hidden = true },

        -- AQ scarab coffer items
        [21156] = { Hidden = true },
        [21761] = { Hidden = true },
        [21762] = { Hidden = true },

        -- AQ trash
        [22202] = { Hidden = true },
        [22203] = { Hidden = true },

        -- Naxxramas scraps
        [22376] = { Hidden = true },
        [22373] = { Hidden = true },
        [22374] = { Hidden = true },
        [22375] = { Hidden = true },

        -- Naxxramas runes
        [23055] = { Hidden = true },
        [22682] = { Hidden = true },

        -- Atiesh legendary items
        [22726] = { ClassMask = 1424, Hidden = true },
        [22727] = { ClassMask = 1424, Hidden = true },

        -- Karazhan trash
        [23857] = { Hidden = true },
        [23864] = { Hidden = true },
        [23862] = { Hidden = true },
        [23865] = { Hidden = true },
        [21882] = { Hidden = true },

        -- Magtheridon's gem bag
        -- [34846] = { Hidden = true },

        -- Ashes of A'lar
        [32458] = { Hidden = true },
        
        -- Trade items
        [32897] = { Hidden = true },
        [32428] = { Hidden = true },
        [34664] = { Hidden = true },

        -- Warglaives of Azzinoth
        [32837] = { ClassMask = 9, Hidden = true },
        [32838] = { ClassMask = 9, Hidden = true },

        -- Trash gems
        [32228] = { Hidden = true },
        [32231] = { Hidden = true },
        [32229] = { Hidden = true },
        [32249] = { Hidden = true },
        [32230] = { Hidden = true },
        [32227] = { Hidden = true },

        -- Zul'Aman trash
        [33865] = { Hidden = true },
        [33930] = { Hidden = true },
        [33932] = { Hidden = true },
        [33931] = { Hidden = true },
        [33933] = { Hidden = true },

        -- Thoridal
        [34334] = { ClassMask = 13, Hidden = true },

        -- Class restrictions on items
        [16665] = { ClassMask = 4 },
        [16795] = { ClassMask = 128 },
        [16796] = { ClassMask = 128 },
        [16797] = { ClassMask = 128 },
        [16798] = { ClassMask = 128 },
        [16799] = { ClassMask = 128 },
        [16800] = { ClassMask = 128 },
        [16801] = { ClassMask = 128 },
        [16802] = { ClassMask = 128 },
        [16803] = { ClassMask = 256 },
        [16804] = { ClassMask = 256 },
        [16805] = { ClassMask = 256 },
        [16806] = { ClassMask = 256 },
        [16807] = { ClassMask = 256 },
        [16808] = { ClassMask = 256 },
        [16809] = { ClassMask = 256 },
        [16810] = { ClassMask = 256 },
        [16811] = { ClassMask = 16 },
        [16812] = { ClassMask = 16 },
        [16813] = { ClassMask = 16 },
        [16814] = { ClassMask = 16 },
        [16815] = { ClassMask = 16 },
        [16816] = { ClassMask = 16 },
        [16817] = { ClassMask = 16 },
        [16818] = { ClassMask = 128 },
        [16819] = { ClassMask = 16 },
        [16820] = { ClassMask = 8 },
        [16821] = { ClassMask = 8 },
        [16822] = { ClassMask = 8 },
        [16823] = { ClassMask = 8 },
        [16824] = { ClassMask = 8 },
        [16825] = { ClassMask = 8 },
        [16826] = { ClassMask = 8 },
        [16827] = { ClassMask = 8 },
        [16828] = { ClassMask = 1024 },
        [16829] = { ClassMask = 1024 },
        [16830] = { ClassMask = 1024 },
        [16831] = { ClassMask = 1024 },
        [16832] = { ClassMask = 8 },
        [16833] = { ClassMask = 1024 },
        [16834] = { ClassMask = 1024 },
        [16835] = { ClassMask = 1024 },
        [16836] = { ClassMask = 1024 },
        [16837] = { ClassMask = 64, Faction = classicHorde },
        [16838] = { ClassMask = 64, Faction = classicHorde },
        [16839] = { ClassMask = 64, Faction = classicHorde },
        [16840] = { ClassMask = 64, Faction = classicHorde },
        [16841] = { ClassMask = 64, Faction = classicHorde },
        [16842] = { ClassMask = 64, Faction = classicHorde },
        [16843] = { ClassMask = 64, Faction = classicHorde },
        [16844] = { ClassMask = 64, Faction = classicHorde },
        [16845] = { ClassMask = 4 },
        [16846] = { ClassMask = 4 },
        [16847] = { ClassMask = 4 },
        [16848] = { ClassMask = 4 },
        [16849] = { ClassMask = 4 },
        [16850] = { ClassMask = 4 },
        [16851] = { ClassMask = 4 },
        [16852] = { ClassMask = 4 },
        [16853] = { ClassMask = 2, Faction = classicAlliance },
        [16854] = { ClassMask = 2, Faction = classicAlliance },
        [16855] = { ClassMask = 2, Faction = classicAlliance },
        [16856] = { ClassMask = 2, Faction = classicAlliance },
        [16857] = { ClassMask = 2, Faction = classicAlliance },
        [16858] = { ClassMask = 2, Faction = classicAlliance },
        [16859] = { ClassMask = 2, Faction = classicAlliance },
        [16860] = { ClassMask = 2, Faction = classicAlliance },
        [16861] = { ClassMask = 1 },
        [16862] = { ClassMask = 1 },
        [16863] = { ClassMask = 1 },
        [16864] = { ClassMask = 1 },
        [16865] = { ClassMask = 1 },
        [16866] = { ClassMask = 1 },
        [16867] = { ClassMask = 1 },
        [16868] = { ClassMask = 1 },
        [16897] = { ClassMask = 1024 },
        [16898] = { ClassMask = 1024 },
        [16899] = { ClassMask = 1024 },
        [16900] = { ClassMask = 1024 },
        [16901] = { ClassMask = 1024 },
        [16902] = { ClassMask = 1024 },
        [16903] = { ClassMask = 1024 },
        [16904] = { ClassMask = 1024 },
        [16905] = { ClassMask = 8 },
        [16906] = { ClassMask = 8 },
        [16907] = { ClassMask = 8 },
        [16908] = { ClassMask = 8 },
        [16909] = { ClassMask = 8 },
        [16910] = { ClassMask = 8 },
        [16911] = { ClassMask = 8 },
        [16912] = { ClassMask = 128 },
        [16913] = { ClassMask = 128 },
        [16914] = { ClassMask = 128 },
        [16915] = { ClassMask = 128 },
        [16916] = { ClassMask = 128 },
        [16917] = { ClassMask = 128 },
        [16918] = { ClassMask = 128 },
        [16919] = { ClassMask = 16 },
        [16920] = { ClassMask = 16 },
        [16921] = { ClassMask = 16 },
        [16922] = { ClassMask = 16 },
        [16923] = { ClassMask = 16 },
        [16924] = { ClassMask = 16 },
        [16925] = { ClassMask = 16 },
        [16926] = { ClassMask = 16 },
        [16927] = { ClassMask = 256 },
        [16928] = { ClassMask = 256 },
        [16929] = { ClassMask = 256 },
        [16930] = { ClassMask = 256 },
        [16931] = { ClassMask = 256 },
        [16932] = { ClassMask = 256 },
        [16933] = { ClassMask = 256 },
        [16934] = { ClassMask = 256 },
        [16935] = { ClassMask = 4 },
        [16936] = { ClassMask = 4 },
        [16937] = { ClassMask = 4 },
        [16938] = { ClassMask = 4 },
        [16939] = { ClassMask = 4 },
        [16940] = { ClassMask = 4 },
        [16941] = { ClassMask = 4 },
        [16942] = { ClassMask = 4 },
        [16943] = { ClassMask = 64, Faction = classicHorde },
        [16944] = { ClassMask = 64, Faction = classicHorde },
        [16945] = { ClassMask = 64, Faction = classicHorde },
        [16946] = { ClassMask = 64, Faction = classicHorde },
        [16947] = { ClassMask = 64, Faction = classicHorde },
        [16948] = { ClassMask = 64, Faction = classicHorde },
        [16949] = { ClassMask = 64, Faction = classicHorde },
        [16950] = { ClassMask = 64, Faction = classicHorde },
        [16951] = { ClassMask = 2, Faction = classicAlliance },
        [16952] = { ClassMask = 2, Faction = classicAlliance },
        [16953] = { ClassMask = 2, Faction = classicAlliance },
        [16954] = { ClassMask = 2, Faction = classicAlliance },
        [16955] = { ClassMask = 2, Faction = classicAlliance },
        [16956] = { ClassMask = 2, Faction = classicAlliance },
        [16957] = { ClassMask = 2, Faction = classicAlliance },
        [16958] = { ClassMask = 2, Faction = classicAlliance },
        [16959] = { ClassMask = 1 },
        [16960] = { ClassMask = 1 },
        [16961] = { ClassMask = 1 },
        [16962] = { ClassMask = 1 },
        [16963] = { ClassMask = 1 },
        [16964] = { ClassMask = 1 },
        [16965] = { ClassMask = 1 },
        [16966] = { ClassMask = 1 },
        [18646] = { ClassMask = 16 },
        [18703] = { ClassMask = 4 },
        [18705] = { ClassMask = 4 },
        [19336] = { ClassMask = 4 },
        [19337] = { ClassMask = 256 },
        [19339] = { ClassMask = 128 },
        [19340] = { ClassMask = 1024 },
        [19341] = { ClassMask = 1 },
        [19342] = { ClassMask = 8 },
        [19343] = { ClassMask = 2, Faction = classicAlliance },
        [19344] = { ClassMask = 64, Faction = classicHorde },
        [19345] = { ClassMask = 16 },
        [19716] = { ClassMask = 134 },
        [19717] = { ClassMask = 73 },
        [19718] = { ClassMask = 1296 },
        [19719] = { ClassMask = 73 },
        [19720] = { ClassMask = 1296 },
        [19721] = { ClassMask = 134 },
        [19722] = { ClassMask = 1090 },
        [19723] = { ClassMask = 385 },
        [19724] = { ClassMask = 28 },
        [20264] = { Faction = classicAlliance },
        [20257] = { Faction = classicHorde },
        [20884] = { ClassMask = 1219 },
        [20885] = { ClassMask = 153 },
        [20886] = { ClassMask = 79 },
        [20888] = { ClassMask = 284 },
        [20889] = { ClassMask = 1350 },
        [20890] = { ClassMask = 1424 },
        [20926] = { ClassMask = 401 },
        [20927] = { ClassMask = 153 },
        [20928] = { ClassMask = 29 },
        [20929] = { ClassMask = 79 },
        [20930] = { ClassMask = 1102 },
        [20931] = { ClassMask = 1350 },
        [20932] = { ClassMask = 1474 },
        [20933] = { ClassMask = 1424 },
        [21214] = { ClassMask = 128 },
        [21279] = { ClassMask = 128 },
        [21280] = { ClassMask = 128 },
        [21281] = { ClassMask = 256 },
        [21282] = { ClassMask = 256 },
        [21283] = { ClassMask = 256 },
        [21284] = { ClassMask = 16 },
        [21285] = { ClassMask = 16 },
        [21287] = { ClassMask = 16 },
        [21288] = { ClassMask = 2, Faction = classicAlliance },
        [21289] = { ClassMask = 2, Faction = classicAlliance },
        [21290] = { ClassMask = 2, Faction = classicAlliance },
        [21291] = { ClassMask = 64, Faction = classicHorde },
        [21292] = { ClassMask = 64, Faction = classicHorde },
        [21293] = { ClassMask = 64, Faction = classicHorde },
        [21294] = { ClassMask = 1024 },
        [21295] = { ClassMask = 1024 },
        [21296] = { ClassMask = 1024 },
        [21297] = { ClassMask = 1 },
        [21298] = { ClassMask = 1 },
        [21299] = { ClassMask = 1 },
        [21300] = { ClassMask = 8 },
        [21302] = { ClassMask = 8 },
        [21303] = { ClassMask = 8 },
        [21304] = { ClassMask = 4 },
        [21306] = { ClassMask = 4 },
        [21307] = { ClassMask = 4 },
        [21453] = { Faction = classicAlliance },
        [21454] = { Faction = classicHorde },
        [21486] = { Faction = classicAlliance },
        [21487] = { Faction = classicHorde },
        [21803] = { Faction = classicAlliance },
        [21804] = { Faction = classicHorde },
        [21889] = { ClassMask = 2, Faction = classicAlliance },
        [22349] = { ClassMask = 9 },
        [22350] = { ClassMask = 1094 },
        [22351] = { ClassMask = 400 },
        [22352] = { ClassMask = 9 },
        [22353] = { ClassMask = 9 },
        [22354] = { ClassMask = 9 },
        [22355] = { ClassMask = 9 },
        [22356] = { ClassMask = 9 },
        [22357] = { ClassMask = 9 },
        [22358] = { ClassMask = 9 },
        [22359] = { ClassMask = 1094 },
        [22360] = { ClassMask = 1094 },
        [22361] = { ClassMask = 1094 },
        [22362] = { ClassMask = 1094 },
        [22363] = { ClassMask = 1094 },
        [22364] = { ClassMask = 1094 },
        [22365] = { ClassMask = 1094 },
        [22366] = { ClassMask = 400 },
        [22367] = { ClassMask = 400 },
        [22368] = { ClassMask = 400 },
        [22369] = { ClassMask = 400 },
        [22370] = { ClassMask = 400 },
        [22371] = { ClassMask = 400 },
        [22372] = { ClassMask = 400 },
        [22739] = { ClassMask = 128 },
        [23059] = { ClassMask = 1 },
        [23060] = { ClassMask = 8 },
        [23061] = { ClassMask = 16 },
        [23062] = { ClassMask = 128 },
        [23063] = { ClassMask = 256 },
        [23064] = { ClassMask = 1024 },
        [23065] = { ClassMask = 64, Faction = classicHorde },
        [23066] = { ClassMask = 2, Faction = classicAlliance },
        [23067] = { ClassMask = 4 },
        [23069] = { ClassMask = 400 },
        [23664] = { ClassMask = 64, Faction = classicHorde },
        [23665] = { ClassMask = 64, Faction = classicHorde },
        [23666] = { ClassMask = 2, Faction = classicAlliance },
        [23667] = { ClassMask = 2, Faction = classicAlliance },
        [23668] = { ClassMask = 2, Faction = classicAlliance },
        [29753] = { ClassMask = 1041 },
        [29754] = { ClassMask = 74 },
        [29755] = { ClassMask = 388 },
        [29756] = { ClassMask = 388 },
        [29757] = { ClassMask = 74 },
        [29758] = { ClassMask = 1041 },
        [29759] = { ClassMask = 388 },
        [29760] = { ClassMask = 74 },
        [29761] = { ClassMask = 1041 },
        [29762] = { ClassMask = 388 },
        [29763] = { ClassMask = 74 },
        [29764] = { ClassMask = 1041 },
        [29765] = { ClassMask = 388 },
        [29766] = { ClassMask = 74 },
        [29767] = { ClassMask = 1041 },
        [30236] = { ClassMask = 74 },
        [30237] = { ClassMask = 1041 },
        [30238] = { ClassMask = 388 },
        [30239] = { ClassMask = 74 },
        [30240] = { ClassMask = 1041 },
        [30241] = { ClassMask = 388 },
        [30242] = { ClassMask = 74 },
        [30243] = { ClassMask = 1041 },
        [30244] = { ClassMask = 388 },
        [30245] = { ClassMask = 74 },
        [30246] = { ClassMask = 1041 },
        [30247] = { ClassMask = 388 },
        [30248] = { ClassMask = 74 },
        [30249] = { ClassMask = 1041 },
        [30250] = { ClassMask = 388 },
        [30446] = { ClassMask = 1 },
        [30447] = { ClassMask = 2 },
        [30448] = { ClassMask = 4 },
        [30449] = { ClassMask = 256 },
        [30450] = { ClassMask = 8 },
        [30663] = { ClassMask = 64 },
        [30664] = { ClassMask = 1024 },
        [30665] = { ClassMask = 16 },
        [30720] = { ClassMask = 128 },
        [31089] = { ClassMask = 274 },
        [31090] = { ClassMask = 1160 },
        [31091] = { ClassMask = 69 },
        [31092] = { ClassMask = 274 },
        [31093] = { ClassMask = 1160 },
        [31094] = { ClassMask = 69 },
        [31095] = { ClassMask = 69 },
        [31096] = { ClassMask = 1160 },
        [31097] = { ClassMask = 274 },
        [31098] = { ClassMask = 274 },
        [31099] = { ClassMask = 1160 },
        [31100] = { ClassMask = 69 },
        [31101] = { ClassMask = 274 },
        [31102] = { ClassMask = 1160 },
        [31103] = { ClassMask = 69 },
        [34848] = { ClassMask = 274 },
        [34851] = { ClassMask = 69 },
        [34852] = { ClassMask = 1160 },
        [34853] = { ClassMask = 274 },
        [34854] = { ClassMask = 69 },
        [34855] = { ClassMask = 1160 },
        [34856] = { ClassMask = 274 },
        [34857] = { ClassMask = 69 },
        [34858] = { ClassMask = 1160 },
        [35186] = { ClassMask = 400 },
        [35187] = { ClassMask = 2 },
        [35189] = { ClassMask = 16 },
        [35190] = { ClassMask = 1024 },
        [35191] = { ClassMask = 1024 },
        [35192] = { ClassMask = 64 },
        [35193] = { ClassMask = 64 },
        [35194] = { ClassMask = 68 },
        [35195] = { ClassMask = 35 },
        [35196] = { ClassMask = 35 },
        [35197] = { ClassMask = 1032 },
    },
};

function LootReserve.Data:IsItemInCategories(itemID, categories)
    for _, category in ipairs(categories) do
        if itemID == 0 or category <= 0 then return false; end

        category = self.Categories[category];
        if category and category.Children and self:IsCategoryVisible(category) then
            for _, child in ipairs(category.Children) do
                if child.Loot then
                    for _, lootItem in ipairs(child.Loot) do
                        if lootItem == itemID then
                            return true;
                        end
                    end
                end
            end
        end
    end

    return false;
end

function LootReserve.Data:GetItemCategories(itemID)
    local categories = { };
    for category in pairs(self.Categories) do
        if self:IsItemInCategories(itemID, category) then
            table.insert(categories, category);
        end
    end
    return categories;
end

function LootReserve.Data:IsCategoryVisible(category)
    return not category.Expansion or category.Expansion <= LootReserve:GetCurrentExpansion();
end

function LootReserve.Data.CategorySorter(a, b, aID, bID)
    if aID > 0 and bID > 0 and a.Expansion ~= b.Expansion then
        return a.Expansion > b.Expansion;
    end
    return aID < bID;
end
